(function ()
{
	"use strict";
	class PlatDebug extends Laya.Sprite
	{
		constructor (view)
		{
			super();
			this._view = view;
			this.graphics.drawRect(0, 0, 200, 200, "#FFFFFF");
			this.size(200, 200);
			
			this._k = "visible";
			this._v = false;
			this._i = 0;
			
			this.on(Laya.Event.CLICK, this, this.OnDo);
			Laya.timer.loop(1, this, ()=>{ this.parent && this.parent.setChildIndex(this, this.parent.numChildren-1); });
		}
		OnDo ()
		{
			console.log(this._k, this._v, this._i);
			this._view.getChildAt(this._i)[this._k] = this._v;
		}
		
	}
	
	class PlatData
	{
		constructor
		(
			bpy = 0.5, bpx = 0.5, npy = -1, npx = 0.5,
			bay =   0, bax = 0.5, nay =  0, nax = 0.5,
			bsw =   0, bsh =   0, nsw =  0, nsh =   0,
			prop=false, p = null, t = PlatData.NONE, i = PlatData.NONE
		)
		{
			this.bpx = bpx; this.bpy = bpy; this.bax = bax; this.bay = bay;
			this.npx = npx; this.npy = npy; this.nax = nax; this.nay = nay;
			this.bsw = bsw; this.bsh = bsh; this.nsw = nsw; this.nsh = nsh;
			this.prop = prop;this.p = p; this.t = t; this.i = i;
			if(npy == -1)
			{
				this.npy = (this.bpy>=1 ? this.bpy : Laya.stage.height*this.bpy) + 75;
			}
		}
		SetAnch (nax = 0.5, nay = 0, bax = 0.5, bay = 0)
		{
			this.nax = nax; this.nay = nay;
			this.bax = bax; this.bay = bay;
			return this;
		}
		SetNati (prop=true, t = PlatData.NONE, p = null)
		{
			this.prop = prop; this.t = t; this.p = p;
			return this;
		}
		SetInts (i=PlatData.INSD)
		{
			this.i = i;
			return this;
		}
		SetColor (color=null)
		{
			this.color = color;
			return this;
		}
	}
	PlatData.NONE = 0; PlatData.STOP = 1; PlatData.INSD = 1;
	
	class PlatInters extends Laya.Sprite
	{
		constructor (data)
		{
			super();
			
			this._data = data||new PlatData();
			
			this._btnHide = new Laya.Sprite();
			this._speMark = new Laya.Sprite();
			this.addChild(this._speMark);
			this.addChild(this._btnHide);
			this._btnHide.loadImage("zxtw/ad/common_recommondbg_close.png");
			this._speMark.loadImage("zxtw/ad/common_ad_hint.png");
			this.on(Laya.Event.MOUSE_DOWN, this, this.OnHide);
			
			console.log("显示测试图-Inters");
			this.Draw();
			this._speMark.pos(0, 0);
			this._btnHide.pos(this.width-36, 0);
		}
		Draw ()
		{
			let w = this._data.nsw || Laya.stage.width  * 0.8;
			let h = this._data.nsh || Laya.stage.height * 0.4;
			this.graphics.clear();
			this.graphics.drawRect(0, 0, w, h, this._data.color || "#FFFFFF99");
			this.size(w, h);
			this.pos((Laya.stage.width-w)*0.5, (Laya.stage.height-h)*0.5);
		}
		Show ()
		{
			Laya.stage.addChild(this);
			Laya.timer.clear(this, this.CheckLayer);
			Laya.timer.frameLoop(1, this, this.CheckLayer);
		}
		CheckLayer () { (Laya.stage.getChildAt(Laya.stage.numChildren-1)!=this) && Laya.stage.addChild(this); }
		OnHide ()
		{
			console.log("清理插屏广告容器");
			this.parent && this.parent.removeChild(this);
			Laya.timer.clear(this, this.CheckLayer);
		}
	}
	class PlatBanner extends PlatInters
	{
		constructor (data, name="横幅")
		{
			super(data, name);
		}
		Draw ()
		{
			let w = Laya.stage.width;
			let h = 150;
			this.graphics.clear();
			this.graphics.drawRect(0, 0, w, h, this._data.color || "#FFFFFF99");
			this.size(w, h);
			this.pos(0, Laya.stage.height-this.height);
		}
		OnHide ()
		{
			console.log("清理横幅广告容器");
			this.parent && this.parent.removeChild(this);
			Laya.timer.clear(this, this.CheckLayer);
		}
	}
	class PlatPortal extends PlatInters
	{
		constructor (data, name="互推")
		{
			super(data, name);
		}
		Draw ()
		{
			let w = Laya.stage.width;
			let h = 450;
			this.graphics.clear();
			this.graphics.drawRect(0, 0, w, h, this._data.color || "#FFFFFF99");
			this.size(w, h);
			this.pos(0, Laya.stage.height-this.height);
		}
		OnHide ()
		{
			console.log("清理互推广告容器");
			this.parent && this.parent.removeChild(this);
			Laya.timer.clear(this, this.CheckLayer);
		}
	}
	class PlatNative extends Laya.Sprite
	{
		constructor (call, data)
		{
			super();
			this._btnHide = new Laya.Sprite();
			this._btnLies = new Laya.Sprite();
			this._speMark = new Laya.Sprite();
			this._spePrev = new Laya.Sprite();
			this._speCont = new Laya.Sprite();
			this._txtTitl = new Laya.Text();
			this._txtTitl.fontSize = 30;
			this._txtTitl.fontColor = "#000000";
			this._txtTitl.valign = "bottom";
			this._txtTitl.size(100, 100);
			this._txtTitl.pos(108, -100);
			this.addChild(this._spePrev);
			this.addChild(this._speCont);
			this.addChild(this._speMark);
			this.addChild(this._btnHide);
			this.addChild(this._btnLies);
			this._speCont.addChild(this._txtTitl);
			this._txtSour = new Laya.Text();
			this._txtSour.fontSize = 30;
			this._txtSour.fontColor = "#000000";
			this._txtSour.size(100, 100);
			this.addChild(this._spePrev);
			this.addChild(this._speCont);
			this.addChild(this._speMark);
			this.addChild(this._btnHide);
			this.addChild(this._btnLies);
			this._speCont.addChild(this._txtTitl);
			this._speCont.addChild(this._txtSour);
			this._btnLies.loadImage("zxtw/ad/common_ad_lies.png");
			this._btnHide.loadImage("zxtw/ad/common_recommondbg_close.png");
			this._speMark.loadImage("zxtw/ad/common_ad_hint.png");
			this._btnLies.visible = !!Plat.Ins.GetCfgsData(Plat.ClickCheck);
			this._speMark.mouseEnabled = false;
			this._btnHide.on(Laya.Event.MOUSE_DOWN, this, this.OnHide);
			this._speCont.on(Laya.Event.MOUSE_DOWN, this, this.OnClick);
			this._spePrev.on(Laya.Event.MOUSE_DOWN, this, this.OnClick);
			this._btnLies.on(Laya.Event.MOUSE_DOWN, this, this.OnLies);
			this._call = call;
			this._data = data;
			this._data.bsw && this._data.bsh && this._btnLies.size(this._data.bsw, this._data.bsh);
			this._btnHide.hitArea = !!Plat.Ins.GetCfgsData(Plat.MiniButton) ? new Laya.Rectangle(-36, -40, 36*2, 40*2) : null;
			if(this._data.t == PlatData.STOP)
			{
				this.hitArea = new Laya.Rectangle(0, 0, Laya.stage.width, Laya.stage.height);
				this.on(Laya.Event.MOUSE_DOWN, this, this.OnClickBG);
				this.on(Laya.Event.MOUSE_UP, this, this.OnClickBG);
				this.on(Laya.Event.CLICK, this, this.OnClickBG);
			}
			this._data.p ? this._data.p.addChild(this) : Laya.stage.addChild(this);
			this.SetPost(1);
			Laya.timer.frameLoop(1, this, this.CheckLayer);
		}
		CheckLayer ()
		{
			if(this.parent != Laya.stage)return;
			if(Laya.stage.getChildAt(Laya.stage.numChildren-1) != this)
			{
				Laya.stage.addChild(this);
			}
		}
		SetData (urls, title="", source="")
		{
			console.log("要加载的原生图片", urls, title, source);
			urls && this._speCont.loadImage(urls, Laya.Handler.create(this, this.OnLoad));
			this._txtTitl.text = title;
			this._txtSour.text = source;
		}
		
		SetPost (type)
		{
			let w, h, x, y, s;
			if(type == 1)
			{
				console.log("显示测试图");
				w = this._data.nsw || Laya.stage.width  * 0.8;
				h = this._data.nsh || Laya.stage.height * 0.4;
				this._spePrev.graphics.clear();
				this._spePrev.graphics.drawRect(0, 0, w, h, this._data.color || "#FFFFFF99");
				this._spePrev.hitArea = new Laya.Rectangle(0, 0, w, h);
				this._spePrev.visible = true;
				this._speCont.visible = false;
			}
			else if(type == 2)
			{
				console.log("显示正式图", this._speCont.texture);
				if(this._speCont.texture==null || this._speCont.texture.width<=0 || this._speCont.texture.height<=0)return;
				
				let W = this._speCont.texture.width;
				let H = this._speCont.texture.height;
				if(this._data.nsw && this._data.nsh)
				{
					w = this._data.nsw;
					h = this._data.nsh;
				}
				else
				{
					s = (Laya.stage.width*0.8)/W;
					w = W*s; h = H*s;
				}
				this._speCont.size(w, h);
				this._spePrev.visible = false;
				this._speCont.visible = true;
				this._txtSour.pos(0, h);
			}
			x = (this._data.npx>0 && this._data.npx<=1) ? Laya.stage.width *this._data.npx : (this._data.npx>1) ? this._data.npx : Laya.stage.width *0.5;
			y = (this._data.npy>0 && this._data.npy<=1) ? Laya.stage.height*this._data.npy : (this._data.npy>1) ? this._data.npy : Laya.stage.height*0.5;
			x = x - w * this._data.nax;
			y = y - h * this._data.nay;
			this._spePrev.pos(x, y);
			this._speCont.pos(x, y);
			this._speMark.pos(x, y-37);
			this._btnHide.pos(x+w-36, y-40);
			x = (this._data.bpx>0 && this._data.bpx<=1) ? Laya.stage.width *this._data.bpx : (this._data.bpx>1) ? this._data.bpx : Laya.stage.width *0.5;
			y = (this._data.bpy>0 && this._data.bpy<=1) ? Laya.stage.height*this._data.bpy : (this._data.bpy>1) ? this._data.bpy : Laya.stage.height*0.5;
			x = x - 247*this._data.bax;
			y = y - 127*this._data.bay;
			this._btnLies.pos(x, y);
		}
		
		OnLoad ()
		{
			console.log("原生广告图片加载完成");
			this.SetPost(2);
		}
		
		Clear ()
		{
			console.log("清理原生广告容器");
			this.parent && this.parent.removeChild(this);
			Laya.timer.clear(this, this.CheckLayer);
			this.destroy(true);
		}
		
		OnLies ()
		{
			this.Clear();
			this._call && this._call.runWith(PlatNative.LIES);
		}
		
		OnHide ()
		{
			this.Clear();
			this._call && this._call.runWith(PlatNative.AUTO);
		}
		
		OnClickBG (evt)
		{
			evt.stopPropagation();
		}
		
		OnClick ()
		{
			this.Clear();
			this._call && this._call.runWith(PlatNative.SURE);
		}
	}
	PlatNative.NONE = 0; PlatNative.SURE = 1; PlatNative.AUTO = 2; PlatNative.LIES = 3;
	
	class InsdNative extends Laya.Sprite
	{
		constructor (call, stop=false)
		{
			super();
			
			this._call = call;
			
			this.graphics.drawRect(0, 0, Laya.stage.width, Laya.stage.height, "#00000099");
			this.hitArea = new Laya.Rectangle(0, 0, Laya.stage.width, Laya.stage.height);
			Laya.stage.addChild(this);
			
			Laya.timer.frameLoop(1, this, this.CheckLayer);
			
			this.spBT = new Laya.Sprite();
			this.spBT.loadImage("zxtw/ad/continue.png");
			this.addChild(this.spBT);
			this.spBT.on(Laya.Event.MOUSE_DOWN, this, this.HideInsdNative);
			this.spBT.pos((Laya.stage.width-247)*0.5, Laya.stage.height*0.65-80);
			
			if(stop)
			{
				this.on(Laya.Event.MOUSE_DOWN, this, this.SpBGStopEvent);
			}
			/*this.spBG.on(Laya.Event.MOUSE_DOWN, this, this.SpBGStopEvent);
			 this.spBG.on(Laya.Event.MOUSE_UP, this, this.SpBGStopEvent);
			 this.spBG.on(Laya.Event.CLICK, this, this.SpBGStopEvent);*/
			
			this.addChild(Plat.Ins.ShowNative(new PlatData(Laya.stage.height*0.65), Laya.Handler.create(this, this.HideInsdNative)));
		}
		SpBGStopEvent (evt) { evt.stopPropagation(); }
		HideInsdNative ()
		{
			Laya.timer.clear(this, this.CheckLayer);
			this.parent && this.parent.removeChild(this);
			Plat.Ins.HideNative(true, true);
			this._call && this._call.run();
		}
		CheckLayer ()
		{
			if(this.parent != Laya.stage)return;
			if(Laya.stage.getChildAt(Laya.stage.numChildren-1) != this)
			{
				Laya.stage.addChild(this);
			}
		}
	}
	
	class Plat
	{
		static get Ins() { return Plat._self; }
		static InitCfgsData(cfgs, type, data)
		{
			cfgs[type[0]] = cfgs[type[0]] || {};
			cfgs[type[0]][type[1]] = data;
		}
		
		constructor(name = Plat.PLAT_PC, PTID = 2123, bannerH = 150)
		{
			Plat._self = this;
			this._name = name;
			this._PTID = PTID;
			this._banH = bannerH;
			this._banR = new Laya.Rectangle();
			this.Init();
			console.log("创建了平台" + this._name);
		}
		Check(name) { return this._name == name; }
		RegCall(call) { this._call = call; }
		Init()
		{
			this.company = "\n著作权人：北京亦乐通科技发展有限公司。";
			this.softsID = "\n软著登记号：2019SR0699569";
			this.loginID = "106810771";
			this.IDIsTest = false;
			this.IDBanner = this.IDIsTest?"testw6vs28auh3":"p2512vhlo7";
			this.IDInters = this.IDIsTest?"testb4znbuh3n2":"a958xej7lg";
			this.IDNative = this.IDIsTest?"u7m3hc4gvm":"c5ftk5qqwe";
			this.IDVideos = this.IDIsTest?"e7hm5vx799":"t7gxvzhkyf";
			this._game = 2142;
			this._vers = 1101;
			
			this.privGaps = 20;
			
			this._ctrlData = { status: 2 };
			this._cfgsData = this._cfgsBack = {};
			Plat.InitCfgsData(this._cfgsData, Plat.ClickCheck, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.NativeProb, 50);
			Plat.InitCfgsData(this._cfgsData, Plat.OpenCheats, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.PurePacket, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.NativeIntr, 20);
			Plat.InitCfgsData(this._cfgsData, Plat.PageInters, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.PageNative, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.NativeRate, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.VideosRate, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.NativPorta, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.MiniButton, 0);
			Plat.InitCfgsData(this._cfgsData, Plat.VideosIcon, 1);
			let str = "gameid=" + this._game + "&platid=" + this._PTID + "&versionnumber=" + this._vers;
			let send = new Laya.HttpRequest();
			send.on(Laya.Event.ERROR, this, this.OnCtrlErr);
			send.on(Laya.Event.COMPLETE, this, this.OnCtrlCom);
			send.send("https://game.zhangxintuowei.com/s/SwitchingState.aspx", str, "post");
		}
		OnCtrlErr(err) { console.log("ctrl数据错误", err); }
		OnCtrlCom(res)
		{
			try
			{
				this._ctrlData = JSON.parse(res.substring(1, res.length - 1).replace(/\\\"/g, "\""));
			}
			catch (e)
			{
				this._ctrlData = JSON.parse(res.replace(/\\\"/g, "\""));
			}
			if (this._ctrlData.status == 1)
			{
				this._cfgsData = {};
				Plat.InitCfgsData(this._cfgsData, Plat.ClickCheck, 1);
				Plat.InitCfgsData(this._cfgsData, Plat.NativeProb, 70);
				Plat.InitCfgsData(this._cfgsData, Plat.OpenCheats, 0);
				Plat.InitCfgsData(this._cfgsData, Plat.PurePacket, 0);
				Plat.InitCfgsData(this._cfgsData, Plat.NativeIntr, 0);
				Plat.InitCfgsData(this._cfgsData, Plat.PageInters, 1);
				Plat.InitCfgsData(this._cfgsData, Plat.PageNative, 1);
				Plat.InitCfgsData(this._cfgsData, Plat.NativeRate, 50);
				Plat.InitCfgsData(this._cfgsData, Plat.VideosRate, 50);
				Plat.InitCfgsData(this._cfgsData, Plat.NativPorta, 1);
				Plat.InitCfgsData(this._cfgsData, Plat.MiniButton, 1);
				Plat.InitCfgsData(this._cfgsData, Plat.VideosIcon, 0);
				this._ctrlData.data && this.ParseCfgs(this._cfgsData, this._ctrlData.data);
			}
			console.log("ctrl数据完成", this._ctrlData);
		}
		ParseCfgs(cfgs, data)
		{
			for (let dataKey in data)
			{
				let item = data[dataKey];
				if (item["status"] == "1")
				{
					cfgs[dataKey] = cfgs[dataKey] || {};
					for (let itemKey in item)
					{
						cfgs[dataKey][itemKey] = parseInt(item[itemKey]);
					}
				}
				else
				{
					this._cfgsData[dataKey] = this._cfgsBack[dataKey];
				}
			}
		}
		InitBannerRect(bw, bh, sw, sh)
		{
			console.log("banner初始数据", bw, bh, sw, sh);
			bw = bw || sw;
			bh = bh || 150;
			console.log("banner数据校正", bw, bh);
			let s = bw / sw;
			this._banR.width = sw;
			this._banR.height = bh / s;
			this._banR.x = 0;
			this._banR.y = sh - this._banR.height;
			s = sw / Laya.stage.width;
			this._banH = this._banR.height * s;
			console.log("banner计算结果", this._banR.x, this._banR.y, this._banR.width, this._banR.height, this._banH);
		}
		GetBH(main = false) { return this._banH; }
		
		Login (call) { call&&call.runWith(true); }
		SetAges (v) { }
		Quit () {}
		
		ShowVideos(call)
		{
			console.log("播放视频", Plat.Ins.GetCfgsData(Plat.PurePacket), this.isVideosShow);
			if(this.isVideosShow)return;
			if (Plat.Ins.GetCfgsData(Plat.PurePacket))
			{
				call && call.runWith(true);
				return;
			}
			this._callVideos = call;
			this._call && this._call.runWith(Plat.SOUNDS_OFF);
			this.isVideosShow = true;
			this.ShowVideosPlat();
		}
		ShowVideosPlat()
		{
			this._callVideos.runWith(true);
			this._call && this._call.runWith(Plat.SOUNDS_ON);
			this.isVideosShow = false;
		}
		VideoClose(v)
		{
			console.log("视频播放结果", v);
			this.isVideosShow = false;
			this._call && this._call.runWith(Plat.SOUNDS_ON);
			this._callVideos && this._callVideos.runWith(v);
		}
		VideoError(err)
		{
			console.log("激励视频加载失败", err);
			this.isVideosShow = false;
			this._call && this._call.runWith(Plat.SOUNDS_ON);
			this._call && this._call.runWith([Plat.VIDEOS_ERR, err]);
			this._callVideos && this._callVideos.runWith([false, false]);
		}
		
		ShowBanner(type = Plat.BANNER_TYPE_GAME)
		{
			console.log("显示横幅", Plat.Ins.GetCfgsData(Plat.PurePacket), this.isBannerShow);
			if(this.isBannerShow)return;
			if (Plat.Ins.GetCfgsData(Plat.PurePacket))return;
			this._typeBanner = type;
			this.isBannerShow = true;
			this.ShowBannerPlat();
		}
		ShowBannerPlat()
		{
			this._platBanner = this._platBanner || new PlatBanner();
			this._platBanner.Show();
		}
		HideBanner()
		{
			if(!this.isBannerShow)return;
			this.isBannerShow = false;
			this.HideBannerPlat();
		}
		HideBannerPlat() { this._platBanner && this._platBanner.OnHide(); }
		TimeBanner(v) { v ? Laya.timer.loop(5000, this, this.ShowBanner, [this._typeBanner]) : Laya.timer.clear(this, this.ShowBanner); }
		
		ShowPortal()
		{
			console.log("显示互推", Plat.Ins.GetCfgsData(Plat.PurePacket));
			if (Plat.Ins.GetCfgsData(Plat.PurePacket))return;
			if (this.name == Plat.PLAT_PC)
			{
				this._platPortal = this._platPortal || new PlatPortal();
				this._platPortal.Show();
			}
			this.ShowPortalPlat();
		}
		HidePortal()
		{
			this._platPortal && this._platPortal.OnHide();
			this.HidePortalPlat();
		}
		ShowPortalPlat() { }
		HidePortalPlat() { }
		
		ShowInters(data=null, call = null)
		{
			data = data || new PlatData();
			console.log("准备显示插屏", data.i, Plat.Ins.GetCfgsData(Plat.PageInters), Plat.Ins.GetCfgsData(Plat.PurePacket));
			if (Plat.Ins.GetCfgsData(Plat.PurePacket))return;
			if (data.i == PlatData.NONE && !Plat.Ins.GetCfgsData(Plat.PageInters))return;
			this.HideNative();
			Laya.MouseManager.enabled = false;
			Laya.timer.once(1000, this, () => { Laya.MouseManager.enabled = true; });
			this.ShowIntersPlat();
		}
		ShowIntersPlat()
		{
			this._platInters = this._platInters || new PlatInters();
			this._platInters.Show();
		}
		
		OnNativeErrs(err)
		{
			console.log("原生广告加载异常", err);
			this._platNative && this._platNative.Clear();
			this._platNative = null;
		}
		TestNative(ctrl = null)
		{
			console.log("检测原生限制");
			if (ctrl)
			{
				console.log("有控制限制", ctrl);
				if (!this.GetCfgsData(ctrl))return false;
				console.log("控制通过");
			}
			console.log("是否有未关闭原生", this._platNative);
			if (this._platNative)return false;
			let time = (new Date()).getTime();
			let step = parseInt(this.GetCfgsData(Plat.NativeIntr)) * 1000;
			console.log("原生时间限制", time - this._timeNative, step, time - this._timeNative < step);
			if (time - this._timeNative < step)return false;
			this._timeNative = time;
			return true;
		}
		ShowNative(data, call = null, ctrl = null)
		{
			console.log("准备显示原生", data.prop, this.ctrl, this.GetCfgsData(Plat.NativeProb), Plat.Ins.GetCfgsData(Plat.PurePacket));
			if (Plat.Ins.GetCfgsData(Plat.PurePacket))return;
			let native = data.prop ? (this.GetCfgsData(Plat.NativPorta) ? this.GetRate(Plat.NativeProb) : (this._platPortal ? false : this.GetRate(Plat.NativeProb))) : true;
			if (native)
			{
				console.log("权重为原生");
				if (!this.TestNative(ctrl))return;
				this.SetNativeRes(false);
				return this._custom ? this.ShowCustomPlat(data, call) : this.ShowNativePlat(data, call);
			}
			else
			{
				console.log("权重为插屏");
				this.ShowInters(data.SetInts(PlatData.INSD));
				return null;
			}
		}
		ShowNativePlat(data, call = null)
		{
			console.log("显示原生");
			this._callNative = call;
			this._platNative = new PlatNative(Laya.Handler.create(this, this.ReportNativeRate), data);
			return this._platNative;
		}
		ShowCustomPlat(data, call = null)
		{
			if (this.name == Plat.PLAT_PC)
			{
				this._platCustom = this._platCustom || new PlatInters(data);
				this._platCustom.Show();
			}
			return null;
		}
		HideNative(report = true, remove = true)
		{
			console.log("HideNative", report, this._platNative);
			if (this._platNative)
			{
				this._platNative.Clear();
				this._platNative = null;
				remove && (this._callNative = null);
				report && this.ReportNativeRate(PlatNative.AUTO);
			}
		}
		ReportNativeRate(type)
		{
			let v;
			switch (type)
			{
				case PlatNative.NONE : v = false; break;
				case PlatNative.SURE : v = true;  break;
				case PlatNative.AUTO : v = this.GetRate(Plat.NativeRate); break;
				case PlatNative.LIES : v = true; break;
			}
			console.log("ReportNativeRate", type, v);
			v && this.ReportNative();
			this.SetNativeRes(v);
			this._platNative = null;
			this._callNative && this._callNative.runWith(v);
			this._callNative = null;
		}
		ReportNative() { console.log("上报原生"); }
		SetNativeRes(v) { this._restNative = v; }
		
		ShowInsdNative(call, stop = false)
		{
			if (this._insdNative) return;
			this.HideNative();
			if (this._restNative || !this.GetCfgsData(Plat.PageNative) || Plat.Ins.GetCfgsData(Plat.PurePacket))
			{
				call && call.run();
			}
			else
			{
				this._callInsdNative = call;
				this._insdNative = new InsdNative(Laya.Handler.create(this, this.HideInsdNative), stop);
			}
		}
		HideInsdNative()
		{
			this._insdNative = null;
			this._callInsdNative && this._callInsdNative.run();
			this._callInsdNative = null;
		}
		
		Vibrate() { }
		LiesVideo(targ, real, lies)
		{
			this.liesTarg = targ;
			this.liesTarg.first = true;
			this.liesTarg.realCall = real;
			this.liesTarg.liesCall = lies;
			let HitsCall = new Laya.Handler(this, this.LiesVideoCall);
			return [HitsCall, this.LiesVideoCall.bind(this)];
		}
		LiesVideoCall(evt)
		{
			if (this.liesTarg.first && Plat.Ins.GetRate(Plat.VideosRate))
			{
				this.liesTarg.first = false;
				this.liesTarg.liesCall.apply(this.liesTarg, evt);
			}
			else
			{
				this.liesTarg.realCall.apply(this.liesTarg, evt);
				this.liesTarg = null;
			}
		}
		
		AddAdIcon(targ, x = 0, y = 0, a = 1, b = 1, w = 0, h = 0)
		{
			let icon = new Laya.Sprite();
			icon.loadImage("zxtw/ad/icon.png");
			icon.mouseEnabled = false;
			targ.addChild(icon);
			icon.pos(x, y);
			icon.scale(a, b);
			w && (targ.width = w);
			h && (targ.height = h);
			icon.visible = !!this.GetCfgsData(Plat.VideosIcon);
		}
		
		CanShare() { return false; }
		StartRecord()
		{
			console.log("开始录屏", this.isRecord);
			if(this.isRecord)return;
			this.isRecord = true;
			this.StartRecirdPlat();
		}
		StartRecirdPlat () { }
		StopRecord()
		{
			console.log("结束录屏", this.isRecord);
			if(!this.isRecord)return;
			this.isRecord = false;
			this.StopRecordPlat()
		}
		StopRecordPlat () { }
		Share(call = null) { call && call.runWith(true); }
		
		AddDeskIcon(node, x=0, y=0, w=0, h=0)
		{
			console.log("添加桌面图标");
			this._btnDesk = new Laya.Sprite();
			this._btnDesk.loadImage("zxtw/mainui/desk.png");
			this._btnDesk.pos(x, y);
			w && h && this._btnDesk.size(w, h);
			node.addChild(this._btnDesk);
			this._btnDesk.on(Laya.Event.CLICK, this, this.OnDesk);
			this.HasToDesk(Laya.Handler.create(this, (res) => { this._btnDesk.visible = !res; }));
		}
		OnDesk()
		{
			this.AddToDesk(Laya.Handler.create(this, (res) =>{
				if (!res)return;
				this._btnDesk.visible = !res;
			}));
		}
		HasToDesk(call) { call && call.runWith(false); }
		AddToDesk(call) { call && call.runWith(true); }
		
		LoadSubPack(name, succ, fail = null, prog = null) { console.log(name + "分包加载完成"); succ && succ.run(); }
		
		GetRate(type) { return Math.random() * 100 < parseInt(this.GetCfgsData(type)); }
		GetCfgsData(type) { return this._cfgsData[type[0]][type[1]]; }
		
		ShowDebug(view)
		{
			Laya.stage.addChild(new PlatDebug(view));
		}
		
		get subp() { return false; }
		get CDNP() { return ""; }
		get ctrl() { return this._ctrlData.status != 1; }
		get name() { return this._name; }
	}
	Plat.PLAT_PC = "PLAT_TEST";Plat.PLAT_OP = "PLAT_OPPO";Plat.PLAT_VV = "PLAT_VIVO";Plat.PLAT_HW = "PLAT_HUAWEI";
	Plat.PLAT_MZ = "PLAT_MEIZU";Plat.PLAT_QQ = "PLAT_QQ";Plat.PLAT_AD = "PLAT_ANDROID";Plat.PLAT_UC = "PLAT_UC";
	Plat.PLAT_CY = "PLAT_CY";Plat.PLAT_TT = "PLAT_TT";Plat.PLAT_WX = "PLAT_WX";
	Plat.SOUNDS_ON = 1;Plat.SOUNDS_OFF = 2;Plat.VIDEOS_ERR = 3;
	Plat.BANNER_TYPE_READ = 0;Plat.BANNER_TYPE_GAME = 1;Plat.BANNER_TYPE_ENDS = 2;
	Plat.ClickCheck = ["1001", "查看按钮"];//小原生广告
	Plat.NativeProb = ["1001", "原生显示概率"];
	Plat.OpenCheats = ["1007", "启用秘籍"];//测试广告
	Plat.PurePacket = ["1007", "白包模式"];
	Plat.NativeIntr = ["1009", "原生间隔"];//插屏概率弹出
	Plat.PageInters = ["1009", "界面插屏"];
	Plat.PageNative = ["1009", "界面原生"];
	Plat.NativeRate = ["1014", "原生误触"];//自动视频
	Plat.VideosRate = ["1014", "视频误触"];
	Plat.NativPorta = ["1014", "互推原生"];
	Plat.MiniButton = ["1014", "原生关闭按钮"];
	Plat.VideosIcon = ["1014", "视频图标"];
	
	
	class PlatHeal extends Laya.Sprite
	{
		static Show (call=null)
		{
			PlatHeal.Ins = PlatHeal.Ins || new PlatHeal(call);
		}
		
		constructor (call)
		{
			super();
			this.width = Laya.stage.width;
			this.height = Laya.stage.height;
			this.txtDesc = new Laya.Text();
			this.txtDesc.width = Laya.stage.width;
			this.txtDesc.height = Laya.stage.height;
			this.txtDesc.valign = "middle";
			this.txtDesc.align = "center";
			this.txtDesc.fontSize = 30;
			this.txtDesc.font = "SimHei";
			this.txtDesc.color = "#ffffff";
			this.txtDesc.text = "健康游戏忠告\n抵制不良游戏，拒绝盗版游戏。\n注意自我保护，谨防受骗上当。\n适度游戏益脑，沉迷游戏伤身。\n合理安排时间，享受健康生活。" + Plat.Ins.company + Plat.Ins.softsID;
			this.addChild(this.txtDesc);
			this.graphics.drawRect(-Laya.stage.width, -Laya.stage.height, Laya.stage.width*2, Laya.stage.height*2, "#000000");
			Laya.timer.loop(1, this, this.OnLoop);
			Laya.timer.once(5000, this, ()=>{
				Laya.timer.clear(this, this.OnLoop);
				PlatHeal.Ins.parent&&PlatHeal.Ins.parent.removeChild(PlatHeal.Ins)
				call&&call.run()
			});
			this.hitArea = new Laya.Rectangle(-Laya.stage.width, -Laya.stage.height, Laya.stage.width*2, Laya.stage.height*2)
			this.on(Laya.Event.MOUSE_DOWN, this, this.OnStop);
			this.on(Laya.Event.MOUSE_UP  , this, this.OnStop);
			this.on(Laya.Event.CLICK     , this, this.OnStop);
		}
		OnStop (evt) { evt.stopPropagation(); }
		OnLoop () { Laya.stage.addChild(this); }
		onDestroy ()
		{
			PlatHeal.Ins = null;
		}
	}
	class PlatLogin extends Laya.Image
	{
		static Show (call)
		{
			PlatLogin.Ins = PlatLogin.Ins||new PlatLogin();
			PlatLogin.Ins.call = call;
			Laya.stage.addChild(PlatLogin.Ins);
			PlatLogin.Ins.OnLogin();
		}
		
		constructor ()
		{
			super();
			this.hitArea = new Laya.Rectangle(0, 0, Laya.stage.width, Laya.stage.height);
			this.call = null;
			this.on(Laya.Event.MOUSE_DOWN, this, this.OnLogin);
			this.on(Laya.Event.MOUSE_UP  , this, this.OnStop);
			this.on(Laya.Event.CLICK     , this, this.OnStop);
			Laya.timer.loop(1, this, ()=>{ this.parent&&this.parent.addChild(this); });
			// this.graphics.drawRect(0, 0, Laya.stage.width, Laya.stage.height, "#FF000099")
		}
		OnStop  (evt) { evt.stopPropagation(); }
		OnLogin (evt)
		{
			evt && evt.stopPropagation();
			if(PlatLogin.IsLogin)
			{
				this.OnLoginSucc();
			}
			else
			{
				Plat.Ins.Login(Laya.Handler.create(this, this.OnLoginBack))
			}
		}
		OnLoginBack (v)
		{
			PlatLogin.IsLogin = v;
			v && this.OnLoginSucc();
		}
		OnLoginSucc ()
		{
			this.parent && this.parent.removeChild(this);
			this.call && this.call.runWith(true);
			PlatLogin.Ins = null;
		}
	}
	PlatLogin.IsLogin = false;
	class PlatPriv extends Laya.Image
	{
		static Show (x, y, p, call, w=NaN, h=NaN)
		{
			PlatPriv.Ins = PlatPriv.Ins || new PlatPriv(w, h);
			PlatPriv.Ins.pos(x, y);
			PlatPriv.Ins.p = p;
			this.zOrder = 10000000;
			p.addChild(PlatPriv.Ins);
			PlatPriv.Ins.Check(call)
			return PlatPriv.Ins;
		}
		static Check (call) { return PlatPriv.Ins.Check(call); }
		
		constructor (w=NaN, h=NaN)
		{
			super();
			this.zOrder = 10000000;
			this.skin = "zxtw/priv/btn_priv.png";
			this.on(Laya.Event.CLICK, this, this.OnPageShow);
			
			this._keys = "saveKeys_priv";
			this._s = Laya.LocalStorage.getItem(this._keys) || "0";
			this._s = parseInt(this._s);
			
			this._w = w;this._h = h;
		}
		
		OnPageShow ()
		{
			if(!this._page)
			{
				this._page = new PlatPrivPage(new Laya.Handler(this, this.OnPageHide));
				this._page.Init(this._w?this._w:Laya.stage.width*0.8, this._h?this._h:Laya.stage.height*0.8);
				this._page.pos((Laya.stage.width-this._page.width)*0.5, (Laya.stage.height-this._page.height)*0.5);
			}
			this._page.Show();
		}
		
		OnPageHide (v)
		{
			this._s = v;
			Laya.LocalStorage.setItem(this._keys, this._s?"1":"0");
			
			if(!this._s)
			{
				Plat.Ins.Quit();
			}
			else
			{
				this.CallBack();
			}
		}
		
		Check (call)
		{
			this._call = call;
			this._s ? this.CallBack() : this.OnPageShow();
		}
		CallBack ()
		{
			Plat.Ins.SetAges(true);
			this._call&&this._call.run();
		}
		
		Remove ()
		{
			this.parent && this.parent.removeChild(this);
		}
		
		onDestroy () { PlatPriv.Ins = null; }
		
		get priv () { return this._s; }
	}
	class PlatPrivPage extends Laya.Image
	{
		constructor (call)
		{
			super();
			
			this.sizeGrid = "20,20,20,20";
			this.skin = "zxtw/priv/priv_bg.png";
			
			this._txtTitle = new Laya.Text;
			this._txtTitle.fontSize = 60;
			this._txtTitle.text = "隐私协议";
			this._txtTitle.y = 30;
			this.addChild(this._txtTitle);
			
			this._btnY = new Laya.Image();
			this._btnY.skin = "zxtw/priv/btn_y.png";
			this._btnY.right = Plat.Ins.privGaps;
			this._btnY.bottom = 50;
			this.addChild(this._btnY);
			
			this._btnN = new Laya.Image();
			this._btnN.skin = "zxtw/priv/btn_n.png";
			this._btnN.left = Plat.Ins.privGaps;
			this._btnN.bottom = 50;
			this.addChild(this._btnN);
			
			this._btnY.on(Laya.Event.MOUSE_DOWN, this, this.OnA);
			this._btnN.on(Laya.Event.MOUSE_DOWN, this, this.OnA);
			this._btnY.on(Laya.Event.MOUSE_UP  , this, this.OnA);
			this._btnN.on(Laya.Event.MOUSE_UP  , this, this.OnA);
			this._btnY.on(Laya.Event.CLICK     , this, this.OnY);
			this._btnN.on(Laya.Event.CLICK     , this, this.OnN);
			this._call = call;
			
			this.hitArea = new Laya.Rectangle(-Laya.stage.width, -Laya.stage.height, Laya.stage.width*2, Laya.stage.height*2);
			this.on(Laya.Event.MOUSE_DOWN, this, this.OnA);
			this.on(Laya.Event.MOUSE_UP  , this, this.OnA);
			this.on(Laya.Event.CLICK     , this, this.OnA);
		}
		
		Init (W, H)
		{
			this.size(W, H);
			PlatPrivPage.W = W- 80;
			PlatPrivPage.H = H-240;
			this._txtTitle.x = (W-this._txtTitle.width)*0.5;
			Laya.loader.load("zxtw/priv/privacy.txt", Laya.Handler.create(this, this.OnLoad));
		}
		Show () { Laya.timer.loop(1, this, this.OnLoop); }
		OnLoop () { Laya.stage.addChild(this); }
		OnLoad ()
		{
			if(!this._list)
			{
				this._list = new Laya.List;
				this._list.repeatX = 1;
				this._list.vScrollBarSkin = "";
				this._list.elasticEnabled = true;
				this._list.itemRender = PlatPrivItem;
				this._list.pos(40, 100);
				this._list.size(PlatPrivPage.W, PlatPrivPage.H);
				this.addChild(this._list);
				this._list.dataSource = [1];
			}
		}
		
		OnA (evt) { evt.stopPropagation(); }
		OnY (evt) { evt.stopPropagation(); this._call.runWith(1); this.Rem(); }
		OnN (evt) { evt.stopPropagation(); this._call.runWith(0); this.Rem(); }
		Rem ()
		{
			this.parent&&this.parent.removeChild(this);
			Laya.timer.clear(this, this.OnLoop);
		}
	}
	class PlatPrivItem extends Laya.Image
	{
		constructor ()
		{
			super();
			this._txtDesc = new Laya.Text();
			this._txtDesc.fontSize = 30;
			this._txtDesc.wordWrap = true;
			this.addChild(this._txtDesc);
			
			this.width = PlatPrivPage.W;
			this._txtDesc.text = Laya.loader.getRes("zxtw/priv/privacy.txt");
			this._txtDesc.width = this.width;
			this.height = this._txtDesc.height;
		}
	}
	
	class PlatShare extends Laya.Box
	{
		static Create (x, y, p)
		{
			PlatShare.Ins = PlatShare.Ins || new PlatShare();
			PlatShare.Ins.pos(x, y);
			PlatShare.Ins.p = p;
			p.addChild(PlatShare.Ins);
			return PlatShare.Ins;
		}
		constructor ()
		{
			super();
			
			this._btnA = new Laya.Image();
			this._btnB = new Laya.Image();
			this.addChild(this._btnA);
			this.addChild(this._btnB);
			this._btnB.x = 110;
			this._btnB.skin = "zxtw/share/2.png";
			
			this._btnA.on(Laya.Event.CLICK, this, this.OnA);
			this._btnB.on(Laya.Event.CLICK, this, this.OnB);
			
			this._stat = 0
			this.Stat(0)
		}
		
		Stat (v)
		{
			this._stat = v;
			switch (this._stat)
			{
				case 0 :
					this._btnA.skin = "zxtw/share/0.png";
					this._btnB.visible = false;
					break;
				case 1 :
					this._btnA.skin = "zxtw/share/1.png";
					this._btnB.visible = false;
					break;
				case 2 :
					this._btnA.skin = "zxtw/share/0.png";
					this._btnB.visible = true;
					break;
			}
		}
		
		OnA ()
		{
			if(this._stat == 0 || this._stat == 2)
			{
				Plat.Ins.StartRecord();
				this.Stat(1);
			}
			else
			{
				Plat.Ins.StopRecord();
				this.Stat(2);
			}
		}
		OnB ()
		{
			Plat.Ins.Share();
		}
		
		onDestroy ()
		{
			PlatShare.Ins = null;
		}
	}
	
	class PlatPlaneText extends Laya.MeshSprite3D
	{
		constructor(w, h, mat)
		{
			super(Laya.PrimitiveMesh.createPlane(w, h, 1, 1), "PlaneText");
			mat = mat || new Laya.UnlitMaterial();
			this.meshRenderer.material = mat;
			mat.renderMode = Laya.UnlitMaterial.RENDERMODE_TRANSPARENT;
			mat.cull = Laya.RenderState.CULL_NONE;
			mat.alphaTest = !0;
			mat.alphaTestValue = .8;
			this.transform.rotate(new Laya.Vector3(180, 0, 0), !0, !1);
			this.txtDesc = new Laya.Text();
			this.txtDesc.bold = true;
		}
		SetText(text, fontSize = 100, color = "#FFFFFF")
		{
			this.txtDesc.text = text;
			this.txtDesc.color = color;
			this.txtDesc.fontSize = fontSize;
			
			this.renderTexture && this.renderTexture.destroy();
			let w = this.txtDesc.width;
			let h = this.txtDesc.height;
			Laya.stage.addChild(this.txtDesc);
			let i = this.txtDesc.drawToTexture(w, h, 0, 0);
			this.renderTexture = i.bitmap;
			Laya.stage.removeChild(this.txtDesc);
			this.meshRenderer.material.albedoTexture = this.renderTexture;
		}
		getRenderTexture() {return this.renderTexture;}
		getRenderTarget() {return this.txtDesc;}
		getMaterial() {return this.meshRenderer.material;}
		onDestroy() {this.renderTexture && !this.renderTexture.destroyed && this.renderTexture.destroy();}
		get width() {return this.txtDesc.width;}
		get height() {return this.txtDesc.height;}
	}
	class Storage4399
	{
		static setItem (k, v) {        gamebox.setStorageSync(k, v); }
		static getItem (k   ) { return gamebox.getStorageSync(k); }
		static setJSON (k, v) { return this.setItem(k, JSON.stringify(v)); }
		static getJSON (k   )
		{
			let v = this.getItem(k);
			return v ? JSON.parse(v) : null;
		}
		static removeItem(k) { gamebox.removeStorageSync(k); }
		static clear() { gamebox.clearStorageSync(); }
	}
	
	
	class PlatHUAWEI extends Plat
	{
		constructor ()
		{
			super(Plat.PLAT_HW, 2123);
		}
		
		Init ()
		{
			super.Init();
			this._IsInit = false;
		}
		
		
		Login (call)
		{
			console.log("准备登录");
			qg.gameLoginWithReal
			({//调用快游戏登录接口
				forceLogin: 1,//玩家未登录华为帐号或鉴权失败时，是否拉起登录页面。0--不拉取,1--拉取
				appid: this.loginID,//在华为开发者联盟上创建快游戏后分配的唯一标识。
				success: function (data)
				{
					console.log("登录成功返回", data);
					console.log("signIn ok");
					call && call.runWith(true);
				},
				fail: function (data, code)
				{
					console.log("登录失败返回", data, code);
					console.log("gameLogin fail:" + JSON.stringify(data) + ", code:" + code);
					platform.getInstance().tip("登录失败, 稍后重试" + JSON.stringify(data) + ", code:" + code)
					call && call.runWith(false);
				}
			})
		}
		
		SetAges (v)
		{
			if(v)
			{
				qg.setUnderAgeOfPromise(false);
				qg.setConsentStatus(0);
				
				if(this._IsInit)return;
				this._IsInit = true;
				
				this._info = qg.getSystemInfoSync();
				this._ADBanner = qg.createBannerAd({adUnitId:this.IDBanner, adIntervals:60, style:{top:this._info.safeArea.bottom-57, left:0, height:57, width:360}});
				this._ADBanner.onLoad ( ( ) => { console.log("ADBanner加载成功"); });
				this._ADBanner.onError( (err) => { console.log("ADBanner加载失败", err, JSON.stringify(err)); });
				/*this._ADBanner.onResize((obj) => {
				 this.InitBannerRect(obj.width, obj.height, this._info.windowWidth, this._info.windowHeight);
				 this._ADBanner.style = {top:this._banR.y, left:this._banR.x, width:this._banR.width, height:this._banR.height};
				 });*/
				
				this._ADVideos = qg.createRewardedVideoAd({adUnitId:this.IDVideos, success:(code)=>{console.log("视频创建_成功", code, JSON.stringify(err));}, fail:(data, code)=>{console.log("视频创建_失败", JSON.stringify(data), code);}});
				this._ADVideos.onError((err) => { this.VideoError(err); });
				this._ADVideos.onLoad (( ) => { console.log("激励视频加载成功"); this._ADVideos.show();});
				this._ADVideos.onClose((res) => { this.VideoClose(res && res.isEnded); });
				
				/*this._ADNative = qg.createNativeAd({adUnitId: this._IDNative, success:()=>{console.log("原生创建_成功");}, fail:()=>{console.log("原生创建_失败");}});
				this._ADNative.onLoad ((res) => { console.log("原生广告加载完成", err, JSON.stringify(err)); this.OnNativeLoad(res); });
				this._ADNative.onError((err) => { console.log("原生广告加载异常", err, JSON.stringify(err)); this.OnNativeErrs(err); });*/
			}
		}
		
		Quit ()
		{
			qg.exitApplication({
				success : function () {
					console.log("exitApplication success" );
				},
				fail:function(){
					console.log("exitApplication fail");
				},
				complete:function() {
					console.log("exitApplication complete");
				}
			});
		}
		
		ShowVideosPlat () { this._ADVideos.load(); }
		
		ShowBannerPlat () { this._ADBanner.show(); }
		HideBannerPlat () { this._ADBanner.hide(); }
		
		ShowIntersPlat ()
		{
			this._ADInters = qg.createInterstitialAd( { adUnitId:this.IDInters });
			console.log("创建插屏广告huawei", this._ADInters);
			this._ADInters.onLoad ( ( )=>{ console.log("插屏广告加载完成"); this._ADInters.show(); } );
			this._ADInters.onError( (err)=>{ console.log("插屏广告加载失败", err); } );
			this._ADInters.onClose( ( )=>{ console.log("插屏广告用户关闭"); this._ADInters.destroy(); } );
			this._ADInters.load();
		}
		
		ShowNativePlat (rect = null, call=null)
		{
			console.log("显示原生");
			this._ReNative = null;
			this._callNative = call;
			this._shelNative = new PlatNative(Laya.Handler.create(this, this.ReportNativeRate), rect, this.ctrl);
			this._ADNative.load();
			return this._shelNative;
		}
		OnNativeLoad (res)
		{
			console.log("原生加载完成", res, this._shelNative);
			if(!this._shelNative) return;
			if(res && res.adList)
			{
				this._ReNative = res.adList.pop();
				this._ReNative.imgUrlList.length <= 0 && this._ReNative.imgUrlList.push(this._ReNative.icon);
				this._ADNative.reportAdShow({adId: this._ReNative.adId.toString()});
				this._shelNative.SetData(this._ReNative.imgUrlList[0], this._ReNative.title, this._ReNative.source);
			}
		}
		ReportNative () { this._ADNative && this._ReNative && this._ADNative.reportAdClick({adId: this._ReNative.adId.toString()}); }
		
		AddToDesk (call)
		{
			qg.installShortcut({
				success: (res) => { call && call.runWith(res); },
				fail   : (   ) => { call && call.runWith(true); }
			});
		}
		HasToDesk (call)
		{
			qg.hasShortcutInstalled({
				success: (res) => { call && call.runWith(res); },
				fail   : (   ) => { call && call.runWith(true); }
			});
		}
		
		LoadSubPack (name, succ, fail = null, prog = null)
		{
			let task = qg.loadSubpackage({
				name    : name,
				success : (res) => { succ && succ.runWith(res); },
				fail    : (res) => { fail && fail.runWith(res); }
			});
			task.onProgressUpdate(res => { prog && prog.runWith(res); });
		}
		get subp () { return true; }
	}
	
	class PlatTool
	{
		static Init (call=null)
		{
			this.InitPlat().RegCall(call);
		}
		static InitPlat ()
		{
			if(Laya.Browser.onHWMiniGame) return new PlatHUAWEI();
			return new Plat();
		}
	}
	
	
	class PlatBase64
	{
		static BASE64_VALUES;
		static HexChars;
		static Indices;
		static UuidTemplate;
		static Init ()
		{
			var BASE64_KEYS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
			var BASE64_VALUES = new Array(123);
			for (let i = 0; i < 123; ++i) BASE64_VALUES[i] = 64;
			for (let i = 0; i <  64; ++i) BASE64_VALUES[BASE64_KEYS.charCodeAt(i)] = i;
			PlatBase64.BASE64_VALUES = BASE64_VALUES;
			
			PlatBase64.HexChars = "0123456789abcdef".split("");
			
			const _t = ["", "", "", ""];
			PlatBase64.UuidTemplate = _t.concat(_t, "-", _t, "-", _t, "-", _t, "-", _t, _t, _t);
			PlatBase64.Indices = PlatBase64.UuidTemplate.map((function(x, i) { return "-" === x ? NaN : i; })).filter(isFinite);
		}
		
		static Decode(base64)
		{
			if(22 !== base64.length) return base64;
			if(!PlatBase64.BASE64_VALUES)PlatBase64.Init();
			
			PlatBase64.UuidTemplate[0] = base64[0];
			PlatBase64.UuidTemplate[1] = base64[1];
			for (var i = 2, j = 2; i < 22; i += 2)
			{
				var lhs = PlatBase64.BASE64_VALUES[base64.charCodeAt(i)];
				var rhs = PlatBase64.BASE64_VALUES[base64.charCodeAt(i + 1)];
				PlatBase64.UuidTemplate[PlatBase64.Indices[j++]] = PlatBase64.HexChars[lhs >> 2];
				PlatBase64.UuidTemplate[PlatBase64.Indices[j++]] = PlatBase64.HexChars[(3 & lhs) << 2 | rhs >> 4];
				PlatBase64.UuidTemplate[PlatBase64.Indices[j++]] = PlatBase64.HexChars[15 & rhs];
			}
			return PlatBase64.UuidTemplate.join("");
		}
	}
	
	window.PlatData = PlatData; window.Plat = Plat; window.PlatTool = PlatTool;
	window.PlatLogin = PlatLogin;window.PlatHeal = PlatHeal;window.PlatPriv = PlatPriv;
	window.PlatBase64 = PlatBase64;
	
}());
